#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <inttypes.h>
#include <fcntl.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <time.h>

#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>

/*
 * Local constants
 */
#define PORT			1234

#define tv_diff(a, b) ({ \
		long long int __tmpA, __tmpB; \
		__tmpA = (a.tv_sec * 1000000) + a.tv_usec; \
		__tmpB = (b.tv_sec * 1000000) + b.tv_usec; \
		__tmpA - __tmpB; \
	})

#define ts_diff(a, b) ({ \
		long long int __tmpA, __tmpB; \
		__tmpA = (a.tv_sec * 1000000000) + a.tv_nsec; \
		__tmpB = (b.tv_sec * 1000000000) + b.tv_nsec; \
		__tmpA - __tmpB; \
	})


/**
 * main
 * \brief	well...
 */
int main( int argc, char **argv )
{
	struct timespec ts_before, ts_after;
	struct sockaddr_in addr;
	socklen_t addrlen = sizeof(addr);
	char buf[1024];
	int sock, res, len;
	float tdiff = 0.0f;

	/*
	 * create sockets
	 */
	sock = socket( PF_INET, SOCK_DGRAM, 0 );
	if( sock < 0 ) {
		perror( "Creating IPv4 socket" );
		return -1;
	}

	/*
	 * bind sockets
	 */
	addr.sin_family = AF_INET;
	addr.sin_addr.s_addr = INADDR_ANY;
	addr.sin_port = htons( PORT );

	res = bind( sock, (struct sockaddr *)&addr, addrlen );
	if( res < 0 ) {
		perror( "Binding to IPv4 address:port" );
		return -1;
	}

	addr.sin_addr.s_addr = inet_addr( "192.168.0.226" );

	len = sprintf( buf, "00491234567890" );

	clock_gettime( CLOCK_REALTIME, &ts_before );

	res = sendto( sock, buf, len, 0, (struct sockaddr *)&addr, addrlen );
	if( res < 0 ) {
		perror( "sending request" );
		return 1;
	}

	res = recvfrom( sock, buf, len, 0, (struct sockaddr *)&addr, &addrlen );
	if( res <= 0 ) {
		perror( "receiving response" );
		return 1;
	}

	clock_gettime( CLOCK_REALTIME, &ts_after );

	tdiff = (float)ts_diff( ts_after, ts_before ) / 1000;

	printf( "Response:\n  %s\nRTT: %-5.3f usecs\n", buf, tdiff );

	close( sock );

	return 0;
}
