#include <stdio.h>
#include <stdlib.h>
#include <inttypes.h>
#include <string.h>
#include <unistd.h>

#include "utils.h"

int main( void )
{
	struct n_buffer *a;
	char tmp = 0x1F;

	printf( "m_buffer unittest\n" );

	/*
	 * Setup
	 */
	printf( "\ncreating buffer with size 100...\n" );
	a = buffer_create( 100 );


	printf( "\nfilling with 10 chars...\n" );
	for( int x = 0; x < 10; x++ ) {
		buffer_put( a, &tmp, sizeof( tmp ) );
	}
	printf( "\tcurrent position: %ld\n", buffer_getpos( a ) );


	printf( "\nadding 10 chars...\n" );
	for( int x = 0; x < 10; x++ ) {
		buffer_put( a, &tmp, sizeof( tmp ) );
	}
	printf( "\tcurrent position: %ld\n", buffer_getpos( a ) );


	printf( "\nresetting buffer\n" );
	buffer_reset( a );
	printf( "\tcurrent position: %ld\n", buffer_getpos( a ) );


	printf( "\ntrying to write 101 chars...\n" );
	for( int x = 0; x <= 100; x++ ) {
		buffer_put( a, &tmp, sizeof( tmp ) );
	}
	printf( "\tcurrent position: %ld\n", buffer_getpos( a ) );

	printf( "\ndestroying buffer...\n" );
	buffer_destroy( a );

	printf( "\nfinished\n" );
	return 0;
}
