#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "utils.h"

void tsk1( struct coro_task *tsk )
{
	int x;

	printf( "init %d\n", coro_getid( tsk ) );

	for(x=0; x<100; x++) {
		printf( "coro %d: %d\n", coro_getid( tsk ), x );
		coro_yield( tsk );
	}

	printf( "fini %d\n", coro_getid( tsk ) );

	coro_return( tsk );
}

void tsk2( struct coro_task *tsk )
{
	int x;
	struct coro_task *to;

	printf( "init %d\n", coro_getid( tsk ) );

	for(x=0; x<100; x++) {
		printf( "coro %d: %d\n", coro_getid( tsk ), x );

		to = coro_find( tsk, 1 );
		if( coro_yieldto( tsk, to ) < 0 )
			coro_yield( tsk );
	}

	printf( "fini %d\n", coro_getid( tsk ) );

	coro_return( tsk );
}

int main( int argc, char **argv )
{
	struct coro_scheduler coroutines;

	coro_init( &coroutines );

	coro_add_task( &coroutines, tsk1 );
	coro_add_task( &coroutines, tsk1 );
	coro_add_task( &coroutines, tsk1 );
	coro_add_task( &coroutines, tsk2 );

	coro_main( &coroutines );

	return 0;
}
