#include <stdio.h>
#include <pthread.h>
#include <sched.h>

#include "atomic.h"

static atomic_t a, b;

void *runner(void *val)
{
	int x;

	while(atomic_read32(&b) != 0)
		pthread_yield();

	for(x=0; x<1000; x++) {
		atomic_inc32(&a);
		printf("%d : %d\n", pthread_self(), atomic_read32(&a));
		pthread_yield();
	}
}

int main(int argc, char **argv)
{
	pthread_t pt_a, pt_b;

	atomic_mb();
	atomic_rmb();
	atomic_smb();

	atomic_set32(&a, 0);
	atomic_set32(&b, 1);

	pthread_create(&pt_a, 0, &runner, 0);
	pthread_create(&pt_b, 0, &runner, 0);

	atomic_dec32(&b);

	pthread_join(pt_a, 0);
	pthread_join(pt_b, 0);

	return 0;
}
